package com.huimv.admin.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.BasePigpen;
import com.huimv.admin.entity.EnergyFeed;
import com.huimv.admin.entity.EnergyGas;
import com.huimv.admin.mapper.BasePigpenMapper;
import com.huimv.admin.mapper.EnergyFeedMapper;
import com.huimv.admin.service.IEnergyFeedService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@Service
public class EnergyFeedServiceImpl extends ServiceImpl<EnergyFeedMapper, EnergyFeed> implements IEnergyFeedService {

    @Autowired
    private EnergyFeedMapper energyFeedMapper;
    @Autowired
    private BasePigpenMapper basePigpenMapper;
    @Override
    public Result listPigpen(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String id = paramsMap.get("id");

        JSONArray jsonArray = new JSONArray();
        if (id == null || id == "") {
            QueryWrapper<BasePigpen> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("farm_id", farmId).eq("parent_id", 0);
            List<BasePigpen> basePigpens = basePigpenMapper.selectList(queryWrapper);
            for (int i = 0; i < basePigpens.size(); i++) {


                QueryWrapper<BasePigpen> basePigpenQueryWrapper = new QueryWrapper<>();
                basePigpenQueryWrapper.eq("parent_id", basePigpens.get(i).getId()).eq("farm_id", farmId);
                List<BasePigpen> basePigpens1 = basePigpenMapper.selectList(basePigpenQueryWrapper);
                for (BasePigpen basePigpen : basePigpens1) {
                    JSONObject jsonObject = new JSONObject();
                    QueryWrapper<EnergyFeed> queryWrapper1 = new QueryWrapper<>();
                    queryWrapper1.eq("unit_id", basePigpen.getId()).eq("farm_id", farmId)
                            .orderByDesc("create_date").last(" limit 1");
                    EnergyFeed energyFeed = energyFeedMapper.selectOne(queryWrapper1);
                    if (ObjectUtil.isEmpty(energyFeed)) {
                        jsonObject.put("buildName", basePigpen.getBuildName());
                        jsonObject.put("value", 0);
                        jsonObject.put("id", basePigpen.getId());
                    } else {
                        jsonObject.put("buildName", basePigpen.getBuildName());
                        jsonObject.put("value", energyFeed.getFeedValue());
                        jsonObject.put("id", basePigpen.getId());
                    }
                    jsonArray.add(jsonObject);
                }
            }
        } else {
            QueryWrapper<BasePigpen> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("farm_id", farmId).eq("parent_id", id);
            List<BasePigpen> basePigpens = basePigpenMapper.selectList(queryWrapper);
            for (BasePigpen basePigpen : basePigpens) {
                JSONObject jsonObject = new JSONObject();
                QueryWrapper<EnergyFeed> queryWrapper1 = new QueryWrapper<>();
                queryWrapper1.eq("unit_id", basePigpen.getId()).eq("farm_id", farmId)
                        .orderByDesc("create_date").last(" limit 1");
                EnergyFeed energyFeed = energyFeedMapper.selectOne(queryWrapper1);
                if (ObjectUtil.isEmpty(energyFeed)) {
                    jsonObject.put("buildName", basePigpen.getBuildName());
                    jsonObject.put("value", 0);
                    jsonObject.put("id", basePigpen.getId());
                } else {
                    jsonObject.put("buildName", basePigpen.getBuildName());
                    jsonObject.put("value", energyFeed.getFeedValue());
                    jsonObject.put("id", basePigpen.getId());
                }

                jsonArray.add(jsonObject);
            }
        }
        return new Result(ResultCode.SUCCESS,jsonArray);
    }
}
